
; Monitorprogramm fuer CPD3

		TITLE	CPD3DEF

		.Z80



; **********************************************************
;         Vereinbarungsteil fuer CP/M 2.2
; **********************************************************

STACK		EQU	0FE80H

RAMSTART	EQU	0F000H

TPA		EQU	0100H

;CBIOS fuer CP/M 2.2
;
BIOSBASE	EQU	0F000H
BIOSLEN		EQU	1000H		; 4096 Byte
;
BDOSBASE    	EQU	0E200H
BDOSLEN		EQU	0E00H		; 3584 Byte = 28 * 128 		
;
CCPBASE     	EQU	0DA00H	
CCPLEN		EQU	0800H		; 2048 Byte
;
EEROMCCP	EQU	0100H
EEPROMBDOS	EQU	EEROMCCP+CCPLEN	; 0900H

;
USERLW		EQU	4	;Laufwerksregister
IOBYTE		EQU	3	;Intel I/O-Byte
;
SBDOS		EQU	BDOSBASE+6
SCCP		EQU	CCPBASE+03H


; **********************************************************
;         Vereinbarungsteil fuer die Hardware
; **********************************************************



FRQ		EQU	6			; Frequenz in MHz

	; 
	;---Kanaladressen---

; A0 = CONTSEL,  A1 = PORTSEL,  A2 = /CE-PIO1,  A3 = /CE-PIO2,  A4 = /CE-PIO3

PIO1AD		EQU     11111000B		;PIO 1 A Daten
PIO1AC		EQU     11111001B		;PIO 1 A Kommandos

PIO1BD		EQU     11111010B		;PIO 1 B Daten
PIO1BC		EQU     11111011B		;PIO 1 B Kommandos

PIO2AD		EQU     11110100B		;PIO 2 A Daten
PIO2AC		EQU     11110101B		;PIO 2 A Kommandos

PIO2BD		EQU     11110110B		;PIO 2 B Daten
PIO2BC		EQU     11110111B		;PIO 2 B Kommandos

PIO3AD		EQU     11101100B		;PIO 3 A Daten
PIO3AC		EQU     11101101B		;PIO 3 A Kommandos

PIO3BD		EQU     11101110B		;PIO 3 B Daten
PIO3BC		EQU     11101111B		;PIO 3 B Kommandos



; --------------------------------------------
;
; Funktionale Bezeichnung der Ports
;
D_SYS_PORT	EQU	PIO1AD
C_SYS_PORT	EQU	PIO1AC
;
D_ITP2_CON1	EQU	PIO1BD
C_ITP2_CON1	EQU	PIO1BC
;
D_ITP2_CON2	EQU	PIO2AD
C_ITP2_CON2	EQU	PIO2AC
;
D_ITP2_CON3	EQU	PIO2BD
C_ITP2_CON3	EQU	PIO2BC
;
D_ITP2_CON4	EQU	PIO3AD
C_ITP2_CON4	EQU	PIO3AC
;
D_ITP2_CON5	EQU	PIO3BD
C_ITP2_CON5	EQU	PIO3BC


; --------------------------------------------
;
; Bitmaske Port A Daten - alles Eingaenge
BITMSKAE	EQU	11111111B
; Bitmaske Port A Daten - alles Ausgaenge
BITMSKAA	EQU	00000000B


; ============================================
;
;   Datenwerte der PIOs
;
; ============================================
;
; PIO 1 - Port A - Initialwert der Daten des Ausgaberegisters
;
; A0 = Flash A15 = 0 = Low wie Widerstand
; A1 = Flash A16 = 0 = Low wie Widerstand
; A2 = Flash A17 = 0 = Low wie Widerstand
; A3 = Flash A18 = 0 = Low wie Widerstand 
; A4 = RAM A16   = 0 = Low wie Widerstand 
; A5 = RAMSEL    = 0 = Low wie Widerstand - ROM ist aktiv
; A6 = LED_RT    = 0 = Low LED RT aus
; A7 = LED_GE    = 0 = Low LED GE aus

D_SYS_IW		EQU 	00000000B	; Initialwert-Daten Systemport

BIT_FL_A15	EQU	0
BIT_FL_A16	EQU	1
BIT_FL_A17	EQU	2
BIT_FL_A18	EQU	3

BIT_RAM_A16	EQU	4

BIT_RAMSEL	EQU	5

BIT_LED_RT	EQU	6
BIT_LED_GE	EQU	7

; --------------------------------------------
;
; PIO 1 - Port B - Initialwert der Daten des Ausgaberegisters
;
; B0 = D0     = X = (Eingang)
; B1 = D1     = X = (Eingang)
; B2 = D2     = X = (Eingang)
; B3 = D3     = X = (Eingang)
; B4 = DDWR   = 1 = (Ausgang) High wie Widerstand
; B5 = DDAC   = 1 = (Eingang)
; B6 = SDEN   = 0 = (Eingang) SDEN inaktiv
; B7 = SRAC   = 0 = (Eingang) 

D_ITP2_IW	EQU 	00110000B	; Initialwert-Daten ITP2


BIT_ID0		EQU	0
BIT_ID1		EQU	1
BIT_ID2		EQU	2
BIT_ID3		EQU	3

BIT_DDWR	EQU	4
BIT_DDAC	EQU	5
BIT_SDEN	EQU	6
BIT_SRAC	EQU	7

; ============================================
;
;   Kommandowerte der PIOs
;
; ============================================
;
;
; PIO 1 - Port A - Initialwert der Kommandos
;
C_SYS_IW	EQU	BITMSKAA	; Initialwert-Kommandos Systemport

; --------------------------------------------
;
; PIO 1 - Port B - Initialwert der Kommandos
;
; Bitmaske Port B - Initialisierung
; B0 = D0     = 1 - Eingang
; B1 = D1     = 1 - Eingang
; B2 = D2     = 1 - Eingang
; B3 = D3     = 1 - Eingang 
; B4 = DDWR   = 0 - Ausgang
; B5 = DDAC   = 1 - Eingang
; B6 = SDEN   = 1 - Eingang
; B7 = SRAC   = 1 - Eingang 

C_ITP2_IW	EQU 	11101111B	; Initialwert-Kommandos ITP2

; --------------------------------------------
;
; ITP2 Kommandos - Read-Modus
;
; Bitmaske Port B - Initialisierung
; B0 = D0     = 1 - Eingang
; B1 = D1     = 1 - Eingang
; B2 = D2     = 1 - Eingang
; B3 = D3     = 1 - Eingang
; B4 = DDWR   = 0 - Ausgang
; B5 = DDAC   = 1 - Eingang
; B6 = SDEN   = 1 - Eingang
; B7 = SRAC   = 0 - Ausgang 

C_ITP2_RD	EQU 	01101111B	; Read-Kommando ITP2	 

; --------------------------------------------
;
; ITP2 Kommandos - Write-Modus
;
; Bitmaske Port B - Initialisierung
; B0 = D0     = 0 - Ausgang
; B1 = D1     = 0 - Ausgang
; B2 = D2     = 0 - Ausgang
; B3 = D3     = 0 - Ausgang
; B4 = DDWR   = 0 - Ausgang
; B5 = DDAC   = 1 - Eingang
; B6 = SDEN   = 0 - Ausgang
; B7 = SRAC   = 1 - Eingang 

C_ITP2_WR	EQU 	10100000B	; Write-Kommando ITP2	

; ============================================
;
RE_CONST	EQU	1		; Code fuer RECEIVE CONST 
RE_CONIN	EQU	2		; Code fuer RECEIVE CONIN 
SE_CONOUT	EQU	3		; Code fuer SEND CONOUT
RE_SECNT	EQU	4		; Code fuer RECEIVE SECTOR COUNT
RE_SECTOR	EQU	5		; Code fuer RECEIVE SECTOR
RE_RD_ISEC	EQU	6		; Code fuer RECEIVE READ IMAGE SECTOR
SE_WR_ISEC	EQU	7		; Code fuer SEND WRITE IMAGE SECTOR
SE_STD		EQU	8		; Code fuer SEND SECTOR, TRACK, DRIVE
SE_LIST		EQU	9		; Code fuer SEND LIST
RE_ERROR_CODE	EQU	10		; Code fuer RECEIVE ERROR CODE
RE_SAVE_RAM2FL	EQU	11		; Code fuer RECEIVE SAVE RAM-Floppy (RAM in FLASH brennen)
RE_COPY_FL2RAM	EQU	12		; Code fuer RECEIVE COPY RAM-Floppy (FLASH in RAM copieren)
SE_SECNT	EQU	14		; Code fuer SEND SECTOR COUNT

WHO_ARE_YOU	EQU	20		; Code fuer Abfrage der Funktionalitaet
					; des angeschlossenen Geraetes

; ============================================
;

DEVCODE_PC_CPM_EMU   EQU	2	; Code fuer PC-CP/M-Emulator
DEVCODE_KEYBOARD     EQU	3	; Code fuer Tastatur
DEVCODE_DISPLAY      EQU	4	; Code fuer LCD-Display
DEVCODE_RAMFLOPPY    EQU	5	; Code fuer RAM-Floppy
DEVCODE_CONINOUT     EQU        6       ; Code fuer Tastatur und Display

; ============================================
;

	;Vereinbarungsteil ROM/RAM

; ROM von 00000H bis 07FFFH
; RAM von 08000H bis 0FFFFH

RAM_SYSREG	EQU	STACK		; Beginn der Datentabelle am Ende des Stack (Stack
					; zaehlt ja nach unten)

RAM_ZEIT_ZAE1	EQU	RAM_SYSREG+1	; Zeitkonstanten fuer INT_INIT_RD in ITPBAS.INC
RAM_ZEIT_ZAE2	EQU	RAM_ZEIT_ZAE1+1

RAM_AKT_CON	EQU	RAM_ZEIT_ZAE2+1		; aktiver Connector

RAM_CON_TAB	EQU	RAM_AKT_CON+1		; Tabelle fuer aktuellen Datenstand der Connectoren (1-5)

RAM_ITP2_IWX	EQU	RAM_CON_TAB+5		; Tabelle fuer Daten der Ports (5Bytes)

RAM_CON_CONOUT	EQU	RAM_ITP2_IWX+5		; Connector fuer CONOUT (1.Terminal)
RAM_CON_CONOUT2	EQU	RAM_CON_CONOUT+1	; Connector fuer CONOUT2 (2.Terminal)
RAM_CON_CONIN	EQU	RAM_CON_CONOUT2+1	; Connector fuer CONIN (Keyboard)
RAM_CON_DISK	EQU	RAM_CON_CONIN+1		; Connector fuer DISK (HD, Floppy, RAMFLOPPY)
RAM_CON_DISK2	EQU	RAM_CON_DISK+1		; Connector fuer DISK2 (HD, Floppy, RAMFLOPPY)
RAM_CON_BOOT	EQU	RAM_CON_DISK2+1		; Connector fuer BOOT-Datei
RAM_CON_LIST	EQU	RAM_CON_BOOT+1		; Connector fuer LIST (Drucker)


























